using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Previsiones._4_Vistas.Controladoras;
using Exferia_Previsiones.General;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Previsiones._4_Vistas
{
    public partial class P_PrevisionAuxiliarCobroPago : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private P_PrevisionAuxiliarCobroPago_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Variables paginador
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private System.Windows.Forms.Timer g_timer_Paginar = new System.Windows.Forms.Timer();
        #endregion

        #region Objetos en Pantalla
        //Exferia_Label
        internal Exferia_Label Exferia_Label_Importe { get { return ex_lbl_P_PrevisionAuxiliarCobroPago_Importe; } }
        internal Exferia_Label Exferia_Label_Tipo { get { return ex_lbl_P_PrevisionAuxiliarCobroPago_Tipo; } }
        

        //Exferia_TextBox
        internal Exferia_TextBox Exferia_TextBox_Importe { get { return ex_txt_P_PrevisionAuxiliarCobroPago_Importe; } }

        //Exferia_ComboBox
        internal Exferia_ComboBox Exferia_ComboBox_Tipo { get { return ex_cbo_P_PrevisionAuxiliarCobroPago_Tipo; } }

        //Exferia_F3_SoloSeleccion
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Tesorerias { get { return ex_usc_F3_P_PrevisionAuxiliarCobroPago_Tesoreria; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Prevision { get{ return ex_usc_F3_P_PrevisionAuxiliarCobroPago_Prevision; } }

        //Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_Fecha { get { return ex_usc_P_PrevisionAuxiliarCobroPago_Fecha; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_PrevisionAuxiliarCobroPago { get { return ex_Paginador; } }

        //Panel
       // internal Panel Panel_DatosFacturaCabecera { get{ return pnl_DatosFacturaCabecera; } }
        internal Panel Panel_DatosPantalla { get{ return pnl_DatosPantalla; } }
        internal Panel Panel_Tipo { get{ return pnl_P_PrevisionauxiliarCobroPago_Tipo; } }

        //Exferia_Button
        internal Exferia_Button Exferia_Button_Borrar { get { return ex_btn_P_PrevisionAuxiliarCobroPago_Borrar; } }
        internal Exferia_Button Exferia_Button_Grabar { get { return ex_btn_P_PrevisionAuxiliarCobroPago_Grabar; } }
        internal Exferia_Button Exferia_Button_CerrarAbrir { get { return ex_btn_P_RemesaCabeceraCobroPago_CerrarAbrir; } }
        #endregion

        #region Constructor
        public P_PrevisionAuxiliarCobroPago(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle, PRE_Previsiones _mdl_PRE_Previsiones)
        {
            InitializeComponent();

            Repintar.Empezar(this);

            CheckForIllegalCrossThreadCalls = false;

            //Empresa seleccionada y fecha de trabajo ....................................................
            P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
            P_Base_FechaTrabajo = _dtt_FechaTrabajo;

            //Instanciar Controladora
            g_obj_Controladora = new P_PrevisionAuxiliarCobroPago_Controladora(this);

            //Obtengo el modelo
            g_obj_Controladora.g_mdl_PRE_Previsiones = _mdl_PRE_Previsiones;

            //Datos de Opciones detalle
            g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

            //Buscar los Permisos
            g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);


            //Poner los Botones que no se Spueden poner bloqueados o de solo lectura
            ex_btn_P_PrevisionAuxiliarCobroPago_Grabar.Exferia_Button_Bloqueable = false;
            ex_btn_P_PrevisionAuxiliarCobroPago_Borrar.Exferia_Button_Bloqueable = false;
            ex_btn_P_RemesaCabeceraCobroPago_CerrarAbrir.Exferia_Button_Bloqueable = false;

            //Mirar si hay que bloquear los controles, si solo puede ver los datos
            if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
            {
                //Bloqueo los Controles
                SoloLectura.Empezar(this, true);

                ex_btn_P_RemesaCabeceraCobroPago_CerrarAbrir.Enabled = false;
            }
            
            //Titulo de la Pantalla .............................................................................
            P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

            try
            {
                // Label con Empresa Seleccionada 
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log(ex.Message, ex, nameof(P_PrevisionAuxiliarCobroPago) + "/" + nameof(P_PrevisionAuxiliarCobroPago));
                    }
                }
                //....................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = false;
                //.............................................................

                g_obj_Funciones_Paginador = new Funciones_Paginador();

                //Rellenar para los  F3 .......................................
                //TESORERIAS
                ex_usc_F3_P_PrevisionAuxiliarCobroPago_Tesoreria.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_TESORERIA;
                ex_usc_F3_P_PrevisionAuxiliarCobroPago_Tesoreria.Exferia_F3_SoloSeleccion_PantallaContenedora = this;
                ex_usc_F3_P_PrevisionAuxiliarCobroPago_Tesoreria.Exferia_F3_SoloSeleccion_PRINCIPAL_Obligatorio = true;

                //PREVISION
                ex_usc_F3_P_PrevisionAuxiliarCobroPago_Prevision.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_PRE_PREVISION;
                ex_usc_F3_P_PrevisionAuxiliarCobroPago_Prevision.Exferia_F3_SoloSeleccion_PantallaContenedora = this;
                ex_usc_F3_P_PrevisionAuxiliarCobroPago_Prevision.Exferia_F3_SoloSeleccion_PRINCIPAL_Obligatorio = true;
                //.............................................................
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_PrevisionAuxiliarCobroPago) + "/" + nameof(P_PrevisionAuxiliarCobroPago));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }
        }
        #endregion

        #region Inicio de Pantalla
        private void P_PrevisionAuxiliarCobroPago_Load(object sender, EventArgs e)
        {
            try
            {
                //Configurar el Timer para Paginacion ###############################################################
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }
                };
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_PrevisionAuxiliarCobroPago) + "/" + nameof(P_PrevisionAuxiliarCobroPago_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_PrevisionAuxiliarCobroPago_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.Datos_PorDefecto();

                        ActivarBotones(false);

                        //Se cambia el valor de la variable para no salte el evento de se modifico algo
                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;

                        //Poner foco en el primer control
                        ex_usc_F3_P_PrevisionAuxiliarCobroPago_Tesoreria.Exferia_F3_SoloSeleccion_Foco();

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;
                    }
                    //Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                            P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_PrevisionAuxiliarCobroPago.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_PrevisionAuxiliarCobroPago.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log(ex.Message, ex, nameof(P_PrevisionAuxiliarCobroPago) + "/" + nameof(P_PrevisionAuxiliarCobroPago_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if(Exferia_Paginador_PrevisionAuxiliarCobroPago.Visible)
            {
                Exferia_Paginador_PrevisionAuxiliarCobroPago.Visible = _bol_Activar;
            }

            if (ex_btn_P_PrevisionAuxiliarCobroPago_Borrar.Enabled)
            {
                ex_btn_P_PrevisionAuxiliarCobroPago_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Boton Grabar, Borrar, CerrarAbrir y Eventos
        private void ex_btn_P_PrevisionAuxiliarCobroPago_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if (//Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                }
                else
                {
                    g_obj_Controladora.GrabarDatos();
                }
            }
        }

        private void ex_btn_P_PrevisionAuxiliarCobroPago_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                {
                    Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                }
                else
                {
                    g_obj_Controladora.BorrarDatos();
                }
            }
        }

        private void ex_btn_P_RemesaCabeceraCobroPago_CerrarAbrir_Click(object sender, EventArgs e)
        {
            CerrarAbrir();
        }
        private void CerrarAbrir()
        {
            if (g_obj_Controladora.g_mdl_PRE_PrevisionesAuxiliaresCobrosPagos != null)
            {
                //Tiene que tener Permisos para cerrar o abrir la Remesa de Cabecera
                if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Bloquear, true, nameof(ex_btn_P_RemesaCabeceraCobroPago_CerrarAbrir)))
                {
                    //Cerrado (se va abrir)
                    if (ex_btn_P_RemesaCabeceraCobroPago_CerrarAbrir.Tag.ToString().Equals("1"))
                    {
                        //Ver si en verdad esta cerrado
                        if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_CERRADO))
                        {
                            if (g_obj_Controladora.g_bol_GrabarDatos_TerminoCorrectamente)
                            {
                                g_obj_Controladora.Abrir_Documento();
                            }
                        }
                        else
                        {
                            Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_NOCERRADO());
                        }
                    }
                    //Abierto (se va cerrar)
                    else
                    {
                        //ver si esta ya ha sido Cerrada
                        if (g_obj_Controladora.g_str_Estado.Equals(Variables.G_STR_ESTADO_CONTABILIDAD_ABIERTO))
                        {
                            if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_PREGUNTA_CERRAR()))
                            {
                                //Primero Grabo los Datos y Actualizo el Modelo
                                g_obj_Controladora.GrabarDatos();

                                //Te quedas esperando a que termine la tarea asincrona de grabar
                                while (g_obj_Controladora.g_obj_TareaAsincrona_GrabarDatos.IsBusy)
                                    Application.DoEvents();

                                if (g_obj_Controladora.g_bol_GrabarDatos_TerminoCorrectamente)
                                {
                                    g_obj_Controladora.Cerrar_Documento();
                                }
                            }
                        }
                        else
                        {
                            Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_DOCUMENTO_CERRADO());
                        }
                    }
                }
            }
            else
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_DEBEGRABARPRIMERO(g_mdl_PRV_OpcionesDetalle.descripcion_Singular));
            }
        }
        #endregion

        #region Teclas de acceso rapido

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }

            return base.ProcessCmdKey(ref msg, keyData);
        }

        #endregion

        #region Controlar si se modifico algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_CheckBox_CheckedChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_ComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones_Exferia_FechaSeleccion_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_PrevisionAuxiliarCobroPago.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_PrevisionAuxiliarCobroPago.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_PrevisionAuxiliarCobroPago.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_PrevisionAuxiliarCobroPago.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }
        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // Si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
                {
                    // Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_PrevisionAuxiliarCobroPago.txt_ValorPaginaActual - 1);

                    // Asignando al control la pagina actual.
                    Exferia_Paginador_PrevisionAuxiliarCobroPago.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();

                    g_obj_Controladora.RecargarDatos();
                }
            }
        }

        #endregion

        #region F3 Prevision
        private void ex_usc_P_PrevisionAuxiliarCobroPago_Prevision_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            if(ex_usc_F3_P_PrevisionAuxiliarCobroPago_Prevision.Exferia_F3_SoloSeleccion_Id > -1)
            {
                pnl_DatosPantalla.Enabled = true;
            }
            else
            {
                pnl_DatosPantalla.Enabled = false;
            }
        }
        #endregion
    }
}
